(****** Homework 5 for CS-565 Programming Languages - Purdue. ******)
(** !!!Due date: 10/14/2016 by 9:00PM **)
(* All 1, 2, and 3 stars exercises have to be completed. 4 star *)
(* exercises are optional, but completing them can compensate for failed *)
(* exercises of this and future homeworks. *)

(* Submitted by: FILL IN YOUR NAME HERE *)

Require Import Coq.Bool.Bool.
Require Import Coq.Arith.Arith.
Require Import Coq.Arith.EqNat.
Require Import Coq.omega.Omega.
Require Import Maps.
Require Import Smallstep.
Require Import SfLib.
Require Import Stlc.
Require Import StlcProp.
Require Import hw7.

(* Simply Typed Lambda Calculus *)

Module STLC_Exercises.
  Import STLC.
  Import STLCProp.
  Import hw7.STLC_Exercises.

  Example typing_example :
    exists T,
      empty |-
      (tabs x (TArrow TBool TBool)
            (tabs y (TArrow TBool TBool)
                  (tabs z TBool
                        (tapp (tvar y) (tapp (tvar x) (tvar z)))))) \in
        T.
  Proof.
    apply typing_example.
  Qed.

  Example typing_nonexample :
    ~ (exists S, exists T,
            empty |-
            (tabs x S
                  (tapp (tvar x) (tvar x))) \in
              T).
  Proof.
    apply typing_nonexample.
  Qed.

  Theorem soundness : forall t t' T,
      empty |- t \in T ->
      t ==>* t' ->
      ~(stuck t').
  Proof.
    apply soundness.
  Qed.

  Print Assumptions typing_example.
  Print Assumptions typing_nonexample.
  Print Assumptions soundness.

End STLC_Exercises.

Module STLC_Extensions.

  Import hw7.STLC_Extensions.
  Module Examples.

      (* Notations for variable identifiers. *)
      Notation f := (Id 0).
      Notation x := (Id 1).

      (* let f = \x. x in f (f unit) *)
      Definition test :=
        tlet
          f
          (tabs x TUnit (tvar x))
          (tapp (tvar f) (tapp (tvar f) tunit)).
      (* Uncomment these lines. *)
      Example typechecks :
        (@empty ty) |- test \in TUnit.
      Proof. apply Examples.typechecks. Qed.

      Example reduces :
        test ==>* tunit.
      Proof. apply Examples.reduces. Qed.

      Print Assumptions typechecks.
      Print Assumptions reduces.

  End Examples.

  Theorem progress : forall t T,
     empty |- t \in T ->
     value t \/ exists t', t ==> t'.
  Proof. apply progress. Qed.

  Lemma context_invariance : forall Gamma Gamma' t S,
      Gamma |- t \in S  -> (* If t is well-typed in Gamma *)
      (forall x, appears_free_in x t -> Gamma x = Gamma' x)  ->
      (* and a new context Gamma' has the same values for all the free variables in t, *)
      Gamma' |- t \in S. (* t is well-typed in Gamma' *)
  Proof. apply context_invariance. Qed.

  Lemma free_in_context : forall x t T Gamma,
      appears_free_in x t ->
      Gamma |- t \in T ->
      exists T', Gamma x = Some T'.
  Proof. apply free_in_context. Qed.

  Lemma substitution_preserves_typing : forall Gamma x U v t S,
      (update Gamma x U) |- t \in S  ->
      empty |- v \in U   ->
      Gamma |- ([x:=v]t) \in S.
  Proof. apply substitution_preserves_typing. Qed.

  (** Exercise, 3 stars: Update the proof of preservation for the extended language *)

  Theorem preservation : forall t t' T,
      empty |- t \in T  ->
      t ==> t'  ->
      empty |- t' \in T.
  Proof. apply preservation. Qed.
  
  Theorem soundness : forall t t' T,
      empty |- t \in T ->
      t ==>* t' ->
      ~(stuck t').
  Proof. apply soundness. Qed.

  Print Assumptions progress.
  Print Assumptions context_invariance.
  Print Assumptions free_in_context.
  Print Assumptions substitution_preserves_typing.
  Print Assumptions preservation.
  Print Assumptions soundness.
  
End STLC_Extensions.
